@ECHO OFF
:: ===================================================
:: - Batch-Name: 3P-Konv.BAT                         -
:: ===================================================
:: -         Batch by Uwe Morgener - 05.2003         -
:: -      fuer Crosspoint (XP2/OpenXP) und UKAW      -
:: ---------------------------------------------------
:: - Zweck: ndert alle Zeilenabschlsse des RC-Files-
:: - ====== von 0A in 0A0D - falls E-Agent.exe nur   -
:: - 0A geschrieben hat. Ansonsten bleibt der        -
:: - /Inhalt/ des RC-Files unverndert. Die RC-Files -
:: - werden doch /immer/ neu geschrieben und eine    -
:: - eine Kopie erstellt.                            -
:: ---------------------------------------------------
:: - ACHTUNG: Diese Batch ruft sich selber auf. Mit  -
:: -          Anpassungen daher sehr sorgfltig um-  -
:: -          gehen, um keine Endlosschleifen zu er- -
:: -          halten. (ggf. splitten in              -
:: -          "3P-KonvA.bat" und "3P-KonvB.bat")     -
:: ---------------------------------------------------
:: - recht hoher Aufwand, hat aber den Vorteil, da  -
:: - nur die RC-Files konvertiert werden, die von    -
:: - E-Agent gerade neu geschrieben wurden. Das File--
:: - datum aller anderen RC-Files bleibt unberhrt   -
:: ---------------------------------------------------
:: -       (gehrt zum Paket: 3P-Batch v1.20)        -
:: ---------------------------------------------------
IF %2'==/REKURSIV' GOTO Konv

:: ----- Beginn Batch "3P-KonvA.bat"
:: bei denjenigen *.RC-Files die gerade von E-Agent geschrieben wurden
:: Zeilenabschlu 0A nach 0D0A konvertieren
CD %PPP%
FOR %%a IN (%1 %2 %3 %4 %5 %6 %7 %8 %9) DO CALL 3P-Konv.bat %%a /REKURSIV
:: wurde von 3P-Konv eine Fehlermeldung geschrieben?
IF NOT EXIST Error.tmp GOTO NoError
:: Ja, dann Mail daraus generieren
ECHO Fehler: E-Agent hat falsche RC-Files geschrieben...>Betreff.tmp
ECHO Folgende RC-Files sind betroffen:>Body.tmp
ECHO.>>Body.tmp
TYPE Error.tmp>>Body.tmp
DEL Error.tmp
CALL 3P-Sub 3P-Konv Mail
:: Fehler in Log-Datei schreiben
:: LogFile-Verzeichnis einlesen und prfen, ob es auch existiert
CALL VAR GET LogDir FROM %XP%\XPoint.cfg
IF NOT EXIST %LogDir%NUL SET LogDir=%PPP%\
3P LOGECHO $D.$M.$Y $h:$m 3P-Konv.: E-Agent hat falsche RC-Files geschrieben.>>%LogDir%3P-Batch.LOG
:NoError
CD %XP1%
GOTO Ende_1
:: ----- Ende Batch "3P-KonvA.bat"

:Konv
:: ----- Beginn Batch "3P-KonvB.bat"
:: wurde kein Parameter bergeben, dann nur beenden
IF %1'==' GOTO Ende_0
:: RC-File existiert nicht (Newsserver noch nie aufgerufen)
IF NOT EXIST %XP%\%1.rc GOTO Ende_0
:: das zugehrige RC-File kopieren
COPY %XP%\%1.rc %1.rc_ >NUL
:: das kopierte RC-File ggf. konvertieren (0A nach 0A0D)
:: und wieder ins XP-Verzeichnis legen
3P CRLF /E < %1.rc_ > %XP%\%1.rc
:: Prfen, ob 0A nach 0A0D gendert wurden
CALL VAR SET OldSize=SIZE OF %1.rc_
CALL VAR SET NewSize=SIZE OF %XP%\%1.rc
IF %OldSize%'==%NewSize%' GOTO Ende_0
:: Fehlermeldung in Datei schreiben
ECHO %1.rc>> Error.tmp

:Ende_0
:: verwendete Umgebungsvariablen wieder lschen
FOR %%a IN (OldSize NewSize LogDir) DO SET %%a=
:: ----- Ende Batch "3P-KonvB.bat"

:Ende_1
