@ECHO OFF
:: ===================================================
:: - Batch-Name: WDial.BAT                           -
:: ===================================================
:: -         Batch by Uwe Morgener - 05.2003         -
:: -      fuer Crosspoint (XP2/OpenXP) und UKAW      -
:: ---------------------------------------------------
:: - Zweck: Abfrage, was (News und/oder Mail) ber   -
:: - ====== die Box ausgetauscht werden soll und Ver--
:: - bindung zum Internet Service Provider her-      -
:: - stellen. Das Ergebnis der Abfrage wird in die   -
:: - Datei UKAwPara.bat geschrieben. Das Ergebnis    - 
:: - kann dann per CALL UKAwPara.bat von nachfolgen- -
:: - den Batches genutzt werden.                     -
:: - E-Agent.bat ist auf diese bergabe angewiesen.  -
:: - ----------------------------------------------- -
:: -       (gehrt zum Paket: 3P-Batch v1.20)        -
:: ---------------------------------------------------
::
:: aktives Modul (wird ggf. fuer Fehlermeldungen benoetigt)
:: (Sting muss 7 Zeichen lang sein - Fuellzeichen ".")
SET $Mod$=WDial..
GOTO Start

:: =====================================================================
:: "LowLevel-Fehlertexte" ---------------------------------------------
:: Hier werden nur interne Befehle (ECHO, PAUSE, ...) verwendet, da nur diese
:: mit Sicherheit in jeder Umgebung (DOS, Win 9x, Win NT, ...) vorhanden sind.

:NoPPP
ECHO FEHLER in WDial
ECHO ===============
ECHO Unterverzeichnis "%PPP%" existiert nicht...
ECHO Definiert in der Umgebungsvariablen "PPP".
:: Hilfsvariablen lschen
FOR %%a IN (Err Slash_1 Slash_2) DO SET %%a=
GOTO ErrEnde1

:NoRAM
ECHO FEHLER in WDial
ECHO ===============
ECHO Laufwerk und/oder Verzeichnis "%RAM%" existiert nicht...
ECHO Definiert in der Umgebungsvariablen "RAM".
:: Hilfsvariablen lschen
FOR %%a IN (Err Slash_1 Slash_2) DO SET %%a=
GOTO ErrEnde1

:NoXP
ECHO FEHLER in WDial
ECHO ===============
ECHO Unterverzeichnis "%XP%" existiert nicht...
ECHO Definiert in der Umgebungsvariablen "XP".
:: Hilfsvariablen lschen
FOR %%a IN (Err Slash_1 Slash_2) DO SET %%a=
GOTO ErrEnde1

:isSlash
ECHO FEHLER in WDial
ECHO ===============
ECHO Verzeichnisangabe ist: "%Slash_2%"
ECHO Geben Sie das Verzeichnis ohne den abschlieenden Backslash an!
ECHO Definiert in der Umgebungsvariablen "%Slash_1%".
:: Hilfsvariablen lschen
FOR %%a IN (Err Slash_1 Slash_2) DO SET %%a=
GOTO ErrEnde1

:NoDef
ECHO FEHLER in WDial
ECHO ===============
ECHO Die Umgebungsvariablen "XP" und/oder "PPP" existieren nicht...
GOTO ErrEnde

:NoTemp
ECHO FEHLER in WDial
ECHO ===============
ECHO Es ist kein Temporrverzeichnis definiert.
ECHO Definieren Sie dieses ber eine der nachfolgenden
ECHO Umgebungsvariablen:
ECHO         "Temp" oder "Tmp"
ECHO         "RAM"
GOTO ErrEnde

:NoLw
ECHO FEHLER in WDial
ECHO ===============
ECHO Die Umgebungsvariable "PPP" enthlt keine Laufwerksangabe!
GOTO ErrEnde

:NoESpace
ECHO FEHLER in WDial
ECHO ===============
ECHO Zu wenig Umgebungsspeicher verfgbar...
GOTO ErrEnde

:ErrEnde
:: Definiert: Arbeitsumgebung nicht O.K.
ECHO SET UKAwPara=/NoCall> %RAM%\UKAwPara.bat
:ErrEnde1
ECHO.
ECHO Der NetCall wird nicht durchgefhrt!
PAUSE
GOTO Ende

:: "HighLevel-Fehlertexte" --------------------------------------------
:: Text fr Fehlermeldung auswhlen
:: Die eigendliche Ausgabe erfolgt ber 3P-Sub.bat - dadurch mu ich 
:: zwar etwas "hpfen", habe aber "3P-Batch"-Weit nur eine Routine

:WBatErr ------ Aufruf von CALL W.Bat MENU ...
SET UKAwPara=TWBatErr
GOTO ErrEnde2

:NoDial ------ Keinen NetCall-Wunsch angegeben
SET UKAwPara=TNoDial
GOTO ErrEnde2

:Abbruch ------ Abbruch (Esc) durch den Benutzer
SET UKAwPara=TAbbruch
GOTO ErrEnde2

:NoBFG ------ per $CONFIG bergebene *.BFG existiert nicht
SET UKAwPara=TNoBFG
SET Datei=%BFG_Name%.BFG
GOTO ErrEnde2

:isDialIn ------ "Edit/Boxen/<Box>/Edit/Zugang/..." nicht leer
SET UKAwPara=isDialI%XPv%
:: Hilfsvariablen lschen
:: fr XP2
FOR %%a IN (DialInPass DialInUser DialInNumber) DO SET %%a=
:: fr OpenXP
FOR %%a IN (Client-DialUp Client-Phone Client-Login) DO SET %%a=
GOTO ErrEnde2

:DialErr ------ WDial konnte keine Verbindung herstellen
CD %PPP%
SET UKAwPara=TDialErr
GOTO ErrEnde2

:OnSetErr ------ Parameter zur Aktivierung des Dial-Mens unplausibel
SET UKAwPara=OnSetErr
GOTO ErrEnde2

:isSelect ------ Parameter /SELECT und Dial-Men schlieen sich aus
SET Select=
SET Wahl=
SET UKAwPara=isSelect
SET Para1=%_Dial%
SET Para2=%_Select%
GOTO ErrEnde2

:noSupSel ------ Parameter /SELECT nur in Verbindung mit /DIAL erlaubt
SET Select=
SET Wahl=
SET UKAwPara=noSupSel
SET Para1=%_Dial%
SET Para2=%_Select%
GOTO ErrEnde2

:NoAgent ------ E-Agent.exe (aus UKAw) fehlt
SET UKAwPara=NoAgent
GOTO ErrEnde2

:NoServer ------ in Box keine Server eingetragen (Pop3, Smtp und Nntp)
SET UKAwPara=NoServe%XPv%
GOTO ErrEnde2

:WrongXP ------ unbekannte XP-Variante (Linie)
SET UKAwPara=WrongXPw
SET Datei=%_Config%
GOTO ErrEnde2

:noPara ------ bergabeparameter $CONFIG fehlt/an falscher Stelle
:: - wenn 3P-Batch unter OpenXP luft, dann mu der Parameter an 3P-UKAW.bat
::   bergeben werden - Modulnamen austauschen %_run% enthlt diesen
:: - unter XP2 werden die Startparameter direkt an WDial.bat bergeben, dann
::   den Modulnamen nicht austauschen
IF NOT %_run%'==' SET $Mod$=%_run%
SET UKAwPara=noPara
GOTO ErrEnde2

:noBFirst ------ an E-Agent.bat wurde die Pollbox /nicht/ als erstes bergeben
SET UKAwPara=noBFirst
SET noBFirst=
GOTO ErrEnde2

:Err3Pa ------ Fehler in 3Pa.exe aufgetreten
:: wurden die DOS-Umgebungsvariablen nicht/falsch gesetzt, so wurde
:: keine "temp.bat" erstellt, sondern Meldung nur auf Bildschirm
:: ausgegeben und ERRORLEVEL auf 253 gesetzt
IF ERRORLEVEL==253 IF NOT ERRORLEVEL==254 GOTO ErrEnde1
:: %UKAwPara%, %Para1% und ggf. %Para2% setzen (temp.bat wurde 
:: von 3Pa.exe geschrieben, sofern darin ein Fehler auftrat)
CALL %RAM%\temp.bat
DEL %RAM%\temp.bat
GOTO ErrEnde2

:ErrEnde2
:: Fehlermeldung anzeigen und ins Log-File schreiben (3P-Batch.log)
CALL 3P-Sub.bat %UKAwPara% ErrShow
CD %XP1%
:: Hilfsvariablen lschen
FOR %%a IN (Datei Para1 Para2) DO SET %%a=
GOTO Ende
:: =====================================================================

:Start
ECHO.
:: -= Arbeitsumgebung berprfen =-

:: alle Umgebungsvariablen definiert?
IF %XP%'==' GOTO NoDef
IF %PPP%'==' GOTO NoDef
:: temporres Verzeichnis (RAM-Laufwerk) gesetzt?
IF NOT %RAM%'==' GOTO RAMok
:: %RAM% nicht definiert - daher auf Default setzen
IF NOT %TMP%'==' SET RAM=%TMP%
IF NOT %TEMP%'==' SET RAM=%TEMP%
:: Default leider auch nicht gesetzt
IF %RAM%'==' GOTO NoTemp

:RAMok
:: existiert die Tool-Datei und damit auch das Unterverzeichnis
:: in der alle Hilfsdateien der 3P-Batch-Installation liegen?
IF NOT EXIST %PPP%\3P.COM GOTO NoPPP
:: 3P-Batch nutzt auch das XP-LogDir-Verzichnis (3P-Sub.bat)
:: 3P-Batch nutzt auch das XP-Autoexec-Verzichnis (3P-Sub.bat)
:: Exist-Abfrage jedoch nicht notwendig, da dies von XP erledigt wird
:: IF NOT EXIST %XP%\{LogDir}\NUL GOTO {Label}
:: IF NOT EXIST %XP%\{Autoexec}\NUL GOTO {Label}

:: gengend Umgebungsspeicher vorhanden?
%PPP%\3P ESpace 512
IF Errorlevel==1 GOTO NoESpace

:: existiert das Laufwerk/Verzeichnise (/ohne/ abschlieenden Backslash)?
:: Variable initialisieren
SET Err=
:: Temporr-Verzeichnis
CALL %PPP%\3P-Sub.BAT RAM DirExist %RAM%
IF NOT %Err%'==' GOTO %Err%
:: XP-Verzeichnis
CALL %PPP%\3P-Sub.BAT XP DirExist %XP%
IF NOT %Err%'==' GOTO %Err%
:: PPP-Verzeichnis
CALL %PPP%\3P-Sub.BAT PPP DirExist %PPP%
IF NOT %Err%'==' GOTO %Err%

:: Laufwerk aus der Umgebungsvariablen %PPP% ermitteln
%PPP%\3P VARSET Drive=DRIVE OF %PPP% > %RAM%\DriveTMP.bat
IF Errorlevel==1 GOTO NoLw
CALL %RAM%\DriveTMP.bat
:: liegt XP im Rootverzeichnis (%XP%==%Drive%) eines Laufwerks, dann mu "CD \"
:: anstatt "CD %XP%" zum Wechsel in XP-Verzeichnis ausgefhrt werden
SET XP1=%XP%
IF %XP%'==%Drive%' SET XP1=\
:: %XP1% fr die nachfolgenden Batches merken
ECHO SET XP1=%XP1%>> %RAM%\DriveTMP.bat
:: Laufwerk wird spter noch bentigt (E-Agent.bat, Hangup.bat, 3P-In.bat),
:: daher die DriveTMP.bat hier nicht lschen

:: Laufwerk setzen (umgeht Problem, wenn Laufwerk per SUBST zugewiesen wurde)
%Drive%
CD %PPP%

:: alten Semaphor erst einmal lschen, falls hier noch vorhanden
IF EXIST %RAM%\isDial.tmp DEL %RAM%\isDial.tmp

:: bergabeparameter Umgebungsvariabeln zuweisen
::
:: ... bei XP2 (steht der Parameter $CONFIG an 2. Stelle)
IF %2'==' GOTO Next_1
SET _Dial=%1
SET _Config=%2
SET _Select=%3
GOTO Next_2
::
:Next_1
:: ... bei OpenXP (steht der Parameter $CONFIG erster Stelle, 
::                 da einziger bergabeparameter)
IF %1'==' GOTO noPara
SET _Dial=
SET _Config=%1.BFG
SET _Select=

:Next_2
:: Namen der, per $CONFIG bergebenen *.BFG (Pollbox), merken (ohne deren Erweiterung)
:: (wird spter fr die Erstellung der Bericht-Mail gebraucht)
CALL VAR SET BFG_Name=NAME OF %_Config%
ECHO SET BFG_Name=%BFG_Name%> %RAM%\BoxTMP.bat

:: die per $CONFIG bergebene *.BFG existiert nicht
IF NOT EXIST %XP%\%BFG_Name%.BFG GOTO NoBFG

:: XP-Varianten-Erkennung 
:: (%XPv% = -1 = unbekannte Version; %XPv% = 0 = XP2; %XPv% = 1 = OpenXP)
CALL 3P-Sub.bat %_Config% CheckXP
:: XP-Variante unbekannt
IF %XPv%'==-1' GOTO WrongXP

:: E-Agent.exe (UKAW) fehlt
IF NOT EXIST %XP%\E-AGENT.EXE GOTO NoAgent

:: ggf. Default fr XPAuto setzen
IF %XPAuto%'==' SET XPAuto=Manu

:: ggf. Default fr OnLine (WDial soll nicht whlen) setzen
IF %OnLine%'==' SET OnLine=LAN

:: ggf. Men-TimeOut-Default-Wert einstellen
:: (Zeit, nach dessen Ablauf der Default-Menpunkt gewhlt wird)
IF %TimeOut%'==' SET TimeOut=10

:: Men auswhlen (Default-Men ist die 2stufige Version;
:: getrennt nach News und Mail fragen)
IF %Menue%'==' SET Menue=1

:: undokumentierte Menpunkte in Default-Men per %Request%=1 aktivierbar
:: allen anderen Werte fhren zur Deaktivierung
IF NOT %Request%'==1' SET Request=

:: Einstellungen aus der XPoint.cfg auslesen
:: Anzahl der in XP eingestellten Bildschirmzeilen holen 
:: (Config\Anzeige..\Zeilen..)
CALL VAR GET ScreenLines FROM %XP%\XPoint.CFG
::
IF %ScreenLines%'==' SET S_Row=25
IF NOT %ScreenLines%'==' SET S_Row=%ScreenLines%
:: ScreenLines um Anzahl der XP-Statuszeilen reduzieren
CALL VAR SET S_Row=%S_Row%-5
:: prfen, ob ein Ansi-Treiber geladen ist und dies merken
SET S_ANSI=0
3P WBat Ansi?
IF NOT ERRORLEVEL==1 SET S_ANSI=1
::
:: Fenster lschen (ab Zeile 4, %S_Row% Zeilen lschen) und Cursor neu setzen
CALL 3P-Sub.bat %S_Row% 3PClear %S_ANSI%
::
::Hilfsvarablen wieder lschen
FOR %%S IN (ScreenLines S_Row) DO SET %%S=

:: Fehlerflag lschen
SET Err=
:: nur OpenXP: CallTemp.bat schreiben, ber die dann die weiteren 
::    Clienten (E-Agent/Hangup) gestartet werden und die fehlenden
::    Parameter fr WDial.exe zuweisen (%_Dial% und %_Select%)
IF %XPv%'==1' CALL 3P-Sub.bat %1 WrCallBat
:: Fehlerflag gesetzt, dann zur Fehlerroutine
IF NOT %Err%'==' GOTO Err3Pa

:: letzter Netcall vollstndig durchlaufen?
CALL 3P-News.bat WDial_0
:: Nein, dann beenden
IF %UKAwPara%'==/NoCall' GOTO Ende


:: 3. Parameter umwandeln (Groschrift) und merken
CALL VAR SET Select=STRING "%_Select%" /U

:: TimeOut-Zeit fr Anzeige im Men vorbereiten und
:: auf max. 99 Sec begrenzen
:Loop
3P VARSET Time=STRING %TimeOut% >nul
IF ERRORLEVEL==1 SET Time=  [
IF ERRORLEVEL==2 SET Time= [
IF ERRORLEVEL==3 SET TimeOut=99
IF ERRORLEVEL==3 GOTO Loop
:: statische Anzeige der Timout-Zeit im Men
:: undokumentierte Funktion, aktivieren sie die nchste Zeile
::                     und deaktivieren sie die bernchste
rem SET Time=%Time%%TimeOut% Sec]
SET Time=
IF %TimeOut%'==0' SET Time=[waiting]

:: Hilfsvariablen "initialisieren"
FOR %%a IN (MPos Wahl WBat) DO SET %%a=

:: 1. Parameter fr WDial.exe aufbereiten/ggfs. erfragen
:: /optional/: manuelle Auswahl, ob WDial whlen soll, oder nicht
:: (in der Regel sollte WDial bei /DIAL selbst erkennen, ob gewhlt werden mu)
:: im Automodus wird das Wahlmen /nie/ aufgerufen, sondern die Default-Auswahl genutzt
:: ?DIAL        = Dial-Men starten, Default-Auswahl ist "Whlen"
:: ?LAN|?ONLINE = Dial-Men starten, Default-Auswahl ist "schon Online"
:: /DIAL        = kein Dial-Men starten, WDial whlt
:: /LAN|/ONLINE = kein Dial-Men starten, WDial whlt /nicht/
CALL VAR SET Wahl=STRING(1,1) "%_Dial%" /U
CALL VAR SET WDial=STRING(2) "%_Dial%" /U
:: diese Batch erlaubt nur einen der beiden Online-Parameter
:: Grund: im Dial-Men kann sonst kein Default-Menpunkt definiert werden
IF %WDial%'==LAN' IF NOT %OnLine%'==LAN' GOTO OnSetErr
IF %WDial%'==ONLINE' IF NOT %OnLine%'==ONLINE' GOTO OnSetErr
:: Slash anfgen (Parameter vervollstndigen)
SET WDial=/%WDial%
:: -- bergebener 1. Parameter beginnt mit "/", daher kein Auswahlmen anzeigen
IF %Wahl%'==/' GOTO SkipOMen
:: -- bergebener 1. Parameter beginnt mit "?"
:: Dial-Men und Parameter /SELECT nicht erlaubt
:: (Men-Punkt 0+2 wren sonst identisch)
IF %Select%'==/SELECT' GOTO isSelect
:: XP in Automodus, daher kein Auswahlmen anzeigen
IF %XPAuto%'==NoAutoXP' GOTO SkipOMen
:: Default-Menpunkt definieren
IF %WDial%'==/DIAL' SET MPos=1
IF %WDial%'==/%OnLine%' SET MPos=2
IF %WDial%'==/DFUE' SET MPos=3
:: Dial-Men aufrufen ----------------------------
CALL W.Bat BOX @:Online #%MPos%,%TimeOut%
:: Errorlevel bzw. %?% 100 = Esc, Errorlevel 255 = Fehler)
IF Errorlevel==255 GOTO WBatErr
IF %?%'==100' GOTO Abbruch
:: Auswahl zuweisen (Parameter fr WDial.exe setzen)
IF %WBat%'==0' SET WDial=/DIAL
IF %WBat%'==1' SET WDial=/%OnLine%
IF %WBat%'==2' SET WDial=/DIAL
IF %WBat%'==2' SET Select=/SELECT

:: alten Semaphor erst einmal lschen, falls hier noch vorhanden
IF EXIST %RAM%\UKAwDial.tmp DEL %RAM%\UKAwDial.tmp
IF NOT %WBat%'==1' GOTO SkipOMen
:: Auswahl "Rechner ist bereits online" merken (Semaphor setzen)
:: Grund: besondere Behandlung der DF-Verbindung in Hangup.bat
3P QECHO "" >%RAM%\UKAwDial.tmp

:SkipOMen
:: Hilfsvariablen wieder lschen
FOR %%S IN (_Dial _Select) DO SET %%S=
:: Parameter /SELECT nur in Verbindung mit /DIAL erlaubt
IF NOT %WDial%'==/DIAL' IF %Select%'==/SELECT' GOTO noSupSel
:: Errorlevel lschen, falls noch gesetzt
3P Sel 0
:: "JaeSa" starten, 
:: - folgende Daten ermitteln und per Steuerdatei an WDial.bat 
::   bergeben (CALL %RAM%\ParaTMP.bat setzt DOS-Umgebungsvariablen)
:: - ggf. eine <Pollbox>.BFE schreiben
:: XPv.....: Verwendete XP-Variante (0 = XP2; 1 = OpenXP)
:: JaeSa...: Box wurde mit JaeSa konfiguriert (1 = Ja; 0 = Nein)
:: ESetup..: Box wurde  mit E-Setup.exe konfiguriert (1 = Ja; 0 = Nein)
:: BFE.....: <Box>.BFE fuer Netcall erforderlich (1 = Ja; 0 = Nein)
:: MailName: BFG-Liste der abzufragenen Mail-Server(boxen)
:: NewsName: BFG-Liste der abzufragenen News-Server(boxen)
3Pa.exe JaeSa %BFG_Name%
:: innerhalb von 3Pa.exe Fehler aufgetreten?
IF ERRORLEVEL==1 GOTO Err3Pa
:: Ergebnisbernahme von JaeSa (erstellte Steuerdatei starten)
CALL %RAM%\ParaTMP.bat
DEL  %RAM%\ParaTMP.bat

:: /keine/ MultiMailServerBox, daher sind News- und Mail-Serverboxen identisch
:: (E-Agent-Aufruf)
IF %NewsName%'==' SET NewsName=%MailName%

:: bei Verwendung Verwendung des Parameter /SELECT darf in XP kein DialIn-
:: Passwort, -Name und/oder -Nummer eingetragen sein. Das Verhalten von WDial
:: /scheint/ an dieser Stelle sonst nicht ganz eindeutig zu sein
IF NOT %Select%'==/SELECT' GOTO Next_0
::    XP2
IF %XPv%'==0' CALL VAR GET DialInPass, DialInUser, DialInNumber FROM %XP%\%_Config%
IF NOT %DialInPass%%DialInUser%%DialInNumber%'==' GOTO isDialIn
::    OpenXP
IF %XPv%'==1' CALL VAR GET Client-Password, Client-Phone, Client-Login FROM %XP%\%_Config%
IF NOT %Client-Password%%Client-Phone%%Client-Login%'==' GOTO isDialIn
:: Hilfsvariablen brauchen hier nicht gelscht zu werden, da sie nur im 
:: Fehlerfall angelegt werden

:Next_0
:: Parameter 2, und ggf. 3, an WDial.exe "weitergeben"
SET WDial=%WDial% %_Config%
:: Parameter /SELECT im Autostart-Modus /nicht/ bergeben
IF NOT %XPAuto%'==NoAutoXP' SET WDial=%WDial% %Select%

:: Hilfsvariablen lschen
FOR %%a IN (MPos Wahl Select) DO SET %%a=
:: Hilfsvariablen "initialisieren"
FOR %%a IN (UKAwPara MailPara NewsPara) DO SET %%a=
FOR %%a IN (MAIL NEWS) DO SET %%a=0
FOR %%a IN (MailSnd POP3 SMTP MSnd NewsSnd NNTP) DO SET %%a=1
SET Client=3

:: prfe Spoolverzeichnisse auf Inhalt
:: Auswahlmens werden anhand des Ergebnises angepat und die Clients gewhlt
::
:: "NewsSearch" starten, 
:: - folgende Daten ermitteln
:: NewsSnd: News zum Versandt vorhanden? (0 = Ja, 1 = Nein)
:: noFirst: erste angegeben Box = Pollbox? (0 = init, 1 = Nein, 2 = Ja)
SET noFirst=0
FOR %%F IN (%NewsName%) DO CALL 3P-Sub.bat %%F NewsSearch
IF %noFirst%'==1' GOTO noBFirst
:: bei NewsSearch benutzte Hilfsvariablen wieder lschen
FOR %%S IN (PPP_UUZ_Spool Client-Spool noFirst) DO SET %%S=
:: "MailSearch" starten, 
:: - folgende Daten ermitteln und per Steuerdatei an WDial.bat 
::   bergeben (CALL %RAM%\ParaTMP.bat setzt DOS-Umgebungsvariablen)
:: MailSnd: Mail zum Versandt vorhanden? (0 = Ja, 1 = Nein)
:: Pop3...: Pop3Server eingetragen? (0 = Ja, 1 = Nein)
:: Smtp...: SmtpServer eingetragen? (0 = Ja, 1 = Nein)
3Pa.exe MailSearch %BFG_Name% -J:%JaeSa% -E:%ESetup%
:: innerhalb von 3Pa.exe Fehler aufgetreten?
IF ERRORLEVEL==1 GOTO Err3Pa
CALL %RAM%\ParaTMP.bat
DEL  %RAM%\ParaTMP.bat

:: Umgebungsvariablen fr 3P-Sub.bat, 3P-In.bat, usw. merken
:: WICHTIG: /kein/ Leerzeichen zwischen %Variable% und Umleitungszeichen (dem "Grer als")
:: merken, ob XP im automatischen oder manuellen Modus gestartet wurde
ECHO SET XPAuto=%XPAuto%> %RAM%\UKAwPara.bat
:: /alle/ abzufragenden News-Server (*.BFG) merken
ECHO SET NewsName=%NewsName%>> %RAM%\UKAwPara.bat
:: merken, ob Pollbox mit "JaeSa" konfiguriert wurde oder nicht
ECHO SET JaeSa=%JaeSa%>> %RAM%\UKAwPara.bat
:: merken, ob Pollbox mit "E-Setup.exe" konfiguriert wurde oder nicht
ECHO SET ESetup=%ESetup%>> %RAM%\UKAwPara.bat

:: Definition der Hilfsvariablen wieder aufheben und
:: Hilfsvariable %xTime% initialisieren
FOR %%a IN (Ext FileName MailName xTime JaeSa ESetup) DO SET %%a=

:: im Automodus, Mens nur ganz kurz anzeigen
:: Men mu angezeigt werden, da hierber die Entscheidung getroffen wird, 
:: welche Threads (senden und/oder empfangen) aktiviert werden mssen/knnen
:: vom User eingestellte TimeOut-Zeit merken und neue von 1 Sec einstellen
IF %XPAuto%'==NoAutoXP' SET xTime=%TimeOut%
IF %XPAuto%'==NoAutoXP' SET TimeOut=1

:: Men(s) aufrufen ----------------------------
:: Menpunkt "Mail ... senden" nur anbieten,
:: wenn Smtp-Server eingetragen /und/ Mail zum Versand vorhanden
IF %Smtp%%MailSnd%'==00' SET MSnd=0
:: Wenn keine Server (Pop3, Smpt oder Nntp) eingetragen, dann Fehler 
IF %Pop3%%Smtp%%Nntp%'==111' GOTO NoServer
::
IF NOT %Menue%'==2' CALL 3P-Sub.bat x Menue_1
IF %Menue%'==2' CALL 3P-Sub.bat x Menue_2
:: ggf. aufgetretene Fehler bearbeiten
:: Errorlevel bzw. %?% 100 = Esc, Errorlevel 255 = Fehler)
IF Errorlevel==255 GOTO WBatErr
IF %?%'==100' GOTO Abbruch

:: Definition der Hilfsvariablen wieder aufheben
FOR %%a IN (POP3 SMTP MSnd NNTP) DO SET %%a=

:: Auswahl: weder Mail noch News senden oder holen
IF %Mail%%News%'==11' GOTO NoDial

:: Zusatzmeldung definieren
SET MID_Req=News-MID-Requests deaktiviert.

:: -= Parameter fr die Clienten zuweisen =-
:: Mail senden/holen
::IF %MAIL%'==0' 
:: keine Mail-Bearbeitung
IF %MAIL%'==1' SET MailPara=/NoPOP3 /NoSMTP %MailPara%
:: Mail nur holen
IF %MAIL%'==2' SET MailPara=/NoSMTP %MailPara%
:: Mail nur senden
IF %MAIL%'==3' SET MailPara=/NoPOP3 %MailPara%

:: News senden/holen
::IF %NEWS%'==0'
:: keine News-Bearbeitung
IF %NEWS%'==1' SET NewsPara=/NoNews %NewsPara%
:: News nur holen
IF %NEWS%'==2' SET NewsPara=/NoPost %NewsPara%
:: News nur senden
IF %NEWS%'==3' CALL 3P-News.bat SndNews
:: nur MID-Request
IF %NEWS%'==4' CALL 3P-News.bat MID_Req
IF %NEWS%'==4' SET NewsPara=/NoPost %NewsPara%

:: Fehler bei den Vorbereitungen aufgetreten, dann beenden
IF %UKAwPara%'==/NoCall' GOTO Ende

::Hilfsvarablen wieder lschen
FOR %%S IN (NewsName) DO SET %%S=

IF %Mail%'==0' ECHO Mail austauschen...
IF %Mail%'==1' ECHO Keine Mail-Bearbeitung...
IF %Mail%'==2' ECHO Mail nur holen...
IF %Mail%'==3' ECHO Mail nur senden...

IF %News%'==0' ECHO News austauschen...
IF %News%'==1' ECHO Keine News-Bearbeitung...
IF %News%'==2' ECHO News nur holen...
IF %News%'==3' ECHO News nur senden...
IF %News%'==4' ECHO nur MID-Request...

:: Zusatzmeldung ausgeben
IF %News%'==3' ECHO.
IF %News%'==3' ECHO %MID_Req%
ECHO.

:: Vorbereitung fr Hinweis-/Fehlermeldungen in Hangup.bat
:: Hilfsvariablen initialisieren
FOR %%S IN (SndMail SndNews) DO SET %%S=0
IF %Mail%'==0' SET SndMail=1
IF %Mail%'==3' SET SndMail=1
IF %News%'==0' SET SndNews=1
IF %News%'==3' SET SndNews=1
:: merken, ob Mail und/oder News versandt werden soll
ECHO SET SndMail=%SndMail%>> %RAM%\UKAwPara.bat
ECHO SET SndNews=%SndNews%>> %RAM%\UKAwPara.bat
::Hilfsvarablen wieder lschen
FOR %%S IN (SndMail SndNews) DO SET %%S=

:: Client whlen: 1=E-Mail.exe, 2=E-News.exe, 3=E-Agent.exe
::  fr UKAw ab 2.43g (mit E-Agent.exe)
IF %News%'==1' IF NOT %Mail%'==1' SET Client=1
IF NOT %News%'==1' IF %Mail%'==1' SET Client=2
IF NOT %News%'==1' IF NOT %Mail%'==1' SET Client=3

:: E-News.exe (v2.79g) kennt keine Parameter, daher mu bei "News senden" und/oder
:: "News empfangen" und bergabe von Parametern E-Agent.exe gewhlt werden
IF NOT %News%'==1' IF NOT %NewsPara%'==' SET Client=3

::  fr UKAw ab ?.??g (ohne E-Mail.exe und/oder E-News.exe)
::  existiert E-Mail.exe oder E-News.exe /nicht/, dann immer E-Agent nehmen
IF NOT EXIST %XP%\E-MAIL.EXE SET Client=3
IF NOT EXIST %XP%\E-NEWS.EXE SET Client=3

:: Definition der Hilfsvariablen wieder aufheben
FOR %%a IN (WBat MailSnd NewsSnd) DO SET %%a=
SET ?=

CD %XP1%
:: weitere Umgebungsvariablen, hier fr E-Agent.bat, merken
:: WICHTIG: /kein/ Leerzeichen zwischen %Variable% und Umleitungszeichen (dem "Grer als")
ECHO SET UKAwPara=%UKAwPara%>> %RAM%\UKAwPara.bat
ECHO SET Client=%Client%>> %RAM%\UKAwPara.bat
ECHO SET MailPara=%MailPara%>> %RAM%\UKAwPara.bat
ECHO SET NewsPara=%NewsPara%>> %RAM%\UKAwPara.bat

:: "AusgangsFilter"-Batch starten
IF EXIST 3P-Out.bat CALL 3P-out.bat %BFG_Name%
:: sicherheitshalber wieder auf XP-Laufwerk und -Verzeichnis zurcksetzen
%Drive%
CD %XP1%

:: Verbindung zum Provider herstellen
:: WDIAL.EXE /DIAL $CONFIG /SELECT
WDIAL.EXE %WDial%
:: hat WDial einen Fehler gemeldet?
IF Errorlevel==2 GOTO DialErr
:: WDial hat eine Verbindung hergestellt
ECHO WDial.bat: Verbindung hergestellt/besteht >%RAM%\isDial.tmp

:Ende
:: merken, welche XP-Variante (XP2/OpenXP) verwendet wird
IF NOT %RAM%'==' ECHO SET XPv=%XPv%>> %RAM%\UKAwPara.bat

:: ggf. gemerkte TimeOut-Zeit wieder herstellen
IF NOT %xTime%'==' SET TimeOut=%xTime%
:: wenn Ansi-Treiber geladen, dann ANSI-Farbeinstellungen zurcksetzen
IF %S_ANSI%'==1' ECHO [0m
:: wieder zurck ins XP-Verzeichnis wechseln
CD %XP1%
:: Definition der Hilfsvariablen wieder aufheben
FOR %%a IN (Drive XP1 Mail News UKAwPara Client MailPara NewsPara) DO SET %%a=
FOR %%a IN (BFG_Name WDial S_ANSI xTime) DO SET %%a=
:: bei Abbruch der Mens oder Fehlermeldungen, mssen auch folgende 
:: Hilfsvariablen wieder gelscht werden
FOR %%a IN (MailSnd NewsSnd Online Menue NewsName) DO SET %%a=
FOR %%a IN (POP3 SMTP MSnd NNTP $Mod$) DO SET %%a=
SET ?=

:: -=[ Ende der Abarbeitung fr XP2 ]=------------------------------------
:: XP2: Batch beenden
:: (Die Clienten E-Agent.bat und Hangup.bat werden durch XP2 selbst
:: gestartet - es existieren spezielle Eingabefelder in XP2)
IF NOT %XPv%'==1' GOTO Quit
::
:: -=[ Erweiterung fr OpenXP ]=------------------------------------------
:: OpenXP: Die Clienten E-Agent.bat und Hangup.bat starten, welche
:: dann den eigentlichen Netcall durchfhren und anschlieend die 
:: Verbindung ggf. (je nach Parameter) wieder beenden
IF EXIST %RAM%\CallTemp.bat CALL %RAM%\CallTemp.bat DnUpLoad %_Config%
:: existiert die CallTemp.bat nicht, dann die Hangup.bat starten um
:: mglicherweise aufgetretenen Fehlermeldungen abzuarbeiten
IF NOT EXIST %RAM%\CallTemp.bat CALL %PPP%\Hangup.bat /HANGUP %_Config%
IF EXIST %RAM%\CallTemp.bat DEL %RAM%\CallTemp.bat

:Quit
:: Definition der Hilfsvariablen wieder aufheben
FOR %%a IN (XPv _Dial _Config _Select) DO SET %%a=
