@ECHO OFF
:: =====================================================
:: - Batch-Name: 3P-Out.BAT                            -
:: =====================================================
:: -          Batch by Uwe Morgener - 05.2003          -
:: -       fuer Crosspoint (XP2/OpenXP) und UKAW       -
:: -----------------------------------------------------
:: - Zweck: Userschnittstelle um Programme zu starten, -
:: - ====== kurz bevor eine Verbindung zum Provider -  -
:: -        hergestellt wird - z.B. Sicherung der RFC- -
:: -        Spoolverzeichnisse (ausgehende RFC-Nach-   -
:: -        richten)                                   -
:: - ------------------------------------------------- -
:: -       (gehrt zum Paket: 3P-Batch v1.20)          -
:: -----------------------------------------------------
::
:: Diese Batch wird gestartet, kurz bevor eine Verbindung
:: zum Provider hergestellt wird.
::
:: Hier knnen Sie z.B. die RFC-Nachrichten sichern, die
:: mit dem aktuellen Netcall versandt werden sollen.
:: Soetwas lt sich nicht ber den Crosspoint-Ausgangs-
:: filter realisieren, da UUZ.exe erst nach der Abarbei-
:: tung des Crosspoint-Ausgangsfilters gestartet wird.
::
:: Diese Batch wird bei /jeder/ RFC/PPP- bzw. RFC/Client-
:: Box gestartet. Moechten Sie jedoch ein Programm nur bei
:: einer bestimmten Box starten, so werten Sie den Ueber-
:: gabeparameter %1 aus - dieser enthaelt den BFG-Namen
:: der Pollbox (/ohne/ Erweiterung).
::
:: Wichtig: Startverzeichnis ist immer Ihr XP-Verzeichnis
::
:: -=[ SpoolBAK starten, wenn installiert ]=-----------------
:: ausgehende RFC-Nachrichten sichern
IF EXIST %SPB%\SpoolBAK.bat CALL %SPB%\SpoolBAK.bat Save Out
:: Datum des Netcallstarts merken (nur wenn tClient.bat nicht existiert!)
:: (Vorbereitung fr: eingehende RFC-Nachrichten sichern)
IF EXIST %PPP%\tClient.bat GOTO SkipInit
IF EXIST %SPB%\SpoolBAK.bat CALL %SPB%\SpoolBAK.bat Init
:SkipInit
:: -=[ SpoolBAK starten: Ende ]=-----------------------------
::
::
:: -=[ userspezifische Eintrge: Beginn ]=- ---------------------------------
:: (Batches immer mit CALL <Batch> starten!)
::
::         (hier knnten Ihre Batchbefehle/Programmaufrufe stehen.)
::
:: -=[ userspezifische Eintrge: Ende ]=- -----------------------------------
::
:: Hinweis: Rckstellung von Laufwerk und Verzeichnis am Ende dieser Batch
:: auf das XP-Verzeichnis ist nicht notwendig - erledigt WDial.bat.
